module MeterpreterDetection_Timing;

function http_request_helper(c: connection)
    {
    local ts = network_time();
    local trip = MeterpreterDetection::id_to_triplet(c$id);

    if (trip in flagged)
        return;

    if (c$id !in win_polling_data)
        win_polling_data[c$id] = [];

    local current_state = win_polling_data[c$id];

    # FIXME: We don't use length for HTTP polls yet
    next_step(current_state, ts, 0, c$uid);
    if (longest(current_state) > threshold)
        {
        add flagged[trip];
        local message=fmt("Meterpreter detected with reason=TIMING_DETECTED, protocol=HTTP, os=WINDOWS");
        MeterpreterDetection::log_a_notice(c, message, MeterpreterDetection::Meterpreter_Detected, T);
        }

    win_polling_data[c$id] = current_state;
    }

# This event captures polls.
event http_request(c: connection, method: string, original_URI: string, unescaped_URI: string, version: string)
    {
    http_request_helper(c);
    }

function http_reply_helper(c: connection)
    {
    # Update last delay
    local ts = network_time();
    local trip = MeterpreterDetection::id_to_triplet(c$id);

    if (trip in flagged)
        return;

    if (c$id !in win_polling_data)
        win_polling_data[c$id] = [];
    local current_state = win_polling_data[c$id];

    current_state$last_delay = ts - current_state$last_timestamp;

    win_polling_data[c$id] = current_state;
    }

# This event is used to compute the round trip time
event http_reply(c: connection, version: string, code: count, reason: string)
    {
    http_reply_helper(c);
    }
