module MeterpreterDetection_Timing;

export {
    redef SSL::disable_analyzer_after_detection = F;
}

function ssl_encrypted_data_helper(c: connection, is_orig: bool, content_type: count, length: count)
    {
    if (content_type != 23)
        return;

    local ts = network_time();
    local trip = MeterpreterDetection::id_to_triplet(c$id);

    if (trip in flagged)
        return;

    if (c$id !in win_polling_data)
        win_polling_data[c$id] = [];

    local current_state = win_polling_data[c$id];

    if (is_orig)
        {
        # Poll
        next_step(current_state, ts, length, c$uid);
        if (longest(current_state) > threshold)
            {
            add flagged[trip];
            local message=fmt("Meterpreter detected with reason=TIMING_DETECTED, protocol=HTTPS, os=WINDOWS");
            MeterpreterDetection::log_a_notice(c, message, MeterpreterDetection::Meterpreter_Detected, T);
            }
        }
    else
        {
        # Update last delay
        current_state$last_delay = ts - current_state$last_timestamp;
        }

    win_polling_data[c$id] = current_state;
    }

event ssl_encrypted_data(c: connection, is_orig: bool, record_version: count, content_type: count, length: count)
    {
    ssl_encrypted_data_helper(c, is_orig, content_type, length);
    }
